#pragma once

#include <Text.h>

namespace Network
{
    namespace HTTP
    {
        class Answer
        {
        private:
            Framework::Text protocol;
            int statusNumber;
            Framework::Text statusText;
            Framework::Text date;
            Framework::Text contentType;
            Framework::Text header;
            Framework::Text data;
            int ref;

        public:
            Answer( const char *answer );

            const char *getContentType() const;
            const char *getData() const;

            Answer *getThis();
            Answer *release();
        };

        class PostRequest
        {
        private:
            Framework::Text path;
            Framework::Text host;
            Framework::Text contentType;
            Framework::Text data;
            unsigned short port;
            int ref;

        public:
            PostRequest( const char *path, const char *host, const char *data, const char *contentType, unsigned short port );

            Answer *execute() const;

            PostRequest *getThis();
            PostRequest *release();
        };
    }
}